package ru.ulstu.admin.service;

import org.springframework.stereotype.Service;
import ru.ulstu.admin.model.AspirantForm;
import ru.ulstu.aspirant.model.Aspirant;
import ru.ulstu.aspirant.service.AspirantService;

import java.util.List;

@Service
public class AdminAspirantService {
    private final AspirantService aspirantService;

    public AdminAspirantService(AspirantService aspirantService) {
        this.aspirantService = aspirantService;
    }

    public List<Aspirant> getAspirants() {
        return aspirantService.getAspirants();
    }

    public Aspirant getAspirantById(Integer id) {
        return aspirantService.getAspirantById(id);
    }

    public void saveAspirant(AspirantForm aspirantForm) {
        Aspirant aspirant = aspirantForm.getId() == null
                ? new Aspirant(aspirantForm)
                : aspirantService.getAspirantById(aspirantForm.getId());
        aspirant.setName(aspirantForm.getName());
        aspirant.setSurname(aspirantForm.getSurname());
        aspirant.setPatronymic(aspirantForm.getPatronymic());
        aspirant.setBase(aspirantForm.getBase());
        aspirant.setCourse(aspirantForm.getCourse());
        aspirant.setManager(aspirantForm.getManager());
        aspirant.setBirthDate(aspirantForm.getBirthDate());
        aspirant.setSpeciality(aspirantForm.getSpeciality());
        aspirant.setTheme(aspirantForm.getTheme());
        aspirantService.save(aspirant);
    }

    public void deleteAspirant(AspirantForm aspirantForm) {
        aspirantService.deleteAspirant(aspirantForm);
    }
}
